Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 140289)
+++ channels/chan_skinny.c	(working copy)
@@ -1851,6 +1851,7 @@
 	memcpy(s->outbuf+skinny_header_size, &req->data, letohl(req->len));
 
 	res = write(s->fd, s->outbuf, letohl(req->len)+8);
+	ast_free(req);
 
 	if (res != letohl(req->len)+8) {
 		ast_log(LOG_WARNING, "Transmit: write only sent %d out of %d bytes: %s\n", res, letohl(req->len)+8, strerror(errno));
@@ -3528,6 +3529,7 @@
 		sub->rtp = NULL;
 	}
 	ast_mutex_unlock(&sub->lock);
+	ast_free(sub);
 	return 0;
 }
 
@@ -4860,6 +4862,7 @@
 	if ((l->hookstate == SKINNY_ONHOOK) && (AST_LIST_NEXT(sub, list) && !AST_LIST_NEXT(sub, list)->rtp)) {
 		do_housekeeping(s);
 	}
+	ast_free(sub);
 	return 1;
 }
 
@@ -5581,6 +5584,7 @@
 				do_housekeeping(s);
 				ast_devstate_changed(AST_DEVICE_NOT_INUSE, "Skinny/%s@%s", l->name, d->name);
 			}
+			ast_free(sub);
 		}
 		break;
 	case SOFTKEY_RESUME:
